#ifndef CGUL_HEAP_P_H
#define CGUL_HEAP_P_H

#include "cgul_heap.h"

CGUL_BEGIN_C

/** Data encapsulated by the <code>cgul_heap</code> class. */
struct cgul_heap {

    /**
     * In an imperative language (like C), a binary heap is typically
     * implemented using an array.  We use a cgul_vector to allow the
     * binary heap to dynamically resize.  Just remember to never
     * cache the pointer to the array because resizing the vector
     * could invalidate the pointer.
     */
    cgul_vector_t v;

    /**
     * Comparison function.
     */
    cgul_heap_primitives__compare_t cf;

};

CGUL_END_C

#endif  /*  CGUL_HEAP_P_H  */
