#ifndef CGUL_RANDOM_CMWC32_P_H
#define CGUL_RANDOM_CMWC32_P_H

#include "cgul_common.h"
#include "cgul_random_cmwc32.h"

CGUL_BEGIN_C

/**
 * Data encapsulated by the <code>cgul_random_cmwc32</code> class.
 */
struct cgul_random_cmwc32 {

    /**
     * The vector that holds PRNs that are waiting to be multiplied.
     */
    cgul_uint32_t* v;

    /**
     * The index into v for the next PRN to be multiplied.
     */
    size_t v_index;

    /**
     * The "carry" in "Complementary Multiply With Carry."  This is
     * just the high 32-bits of the 64-bit result of multiplication
     * adjusted for using the base of (2^32 - 1) (instead of 2^32).
     */
    cgul_uint32_t carry;

};

CGUL_END_C

#endif  /*  CGUL_RANDOM_CMWC32_P_H  */
