#include "cgul.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    unsigned long int index = 0;
    cgul_string_t s = NULL;
    cgul_convspec_t cs = NULL;
    cgul_convspec_t cs2 = NULL;
    cgul_exception_t local = NULL;

    /* Allocate a temporary string to hold the serialized version of cs. */
    s = cgul_string__new(&local);

    /* Allocate cs. */
    cs = cgul_convspec__new(&local);
    cs2 = cgul_convspec__new(&local);

    /* Initialize cs. */
    index = 0;
    cgul_convspec__deserialize(&local, cs, "%-3.4d", &index);

    /* Perform a deep copy of cs. */
    cgul_convspec__copy(&local, cs2, cs);

    /* Serialize cs2. */
    cgul_convspec__serialize(&local, cs2, s);

    /* Print serialized version of cs2. */
    cgul_libc__printf(&local,
                      "cs2 = \"%s\"\n",
                      cgul_string__get_value(&local, s));
    
    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (cs2) {
        cgul_convspec__delete(cs2);
    }
    if (cs) {
        cgul_convspec__delete(cs);
    }
    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
