#include <unistd.h>
#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

int main(int argc, char* argv[])
{
    int rv = 0;
    unsigned long result = 0;
    size_t rcount = 0;
    unsigned char buf[16384];

    try {

#if 1
        cgul_crc32_cxx crc32(0x04c11db7, 0, 0xffffffff, 0, 0);
#else
        cgul_crc32_cxx crc32(0xedb88320, 0xffffffff, 0xffffffff, 1);
#endif

        for (;;) {

            rcount = read(STDIN_FILENO, buf, sizeof(buf));
            if (rcount <= 0) {
                break;
            }

            crc32.update_block(buf, rcount);
        }

        result = crc32.crc();
        cout << result << "  0x" << hex << result << endl;

    } catch (const exception& e) {
        cerr << "Error: " << e.what();
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "Error: " << e.get_message();
        rv = 1;
    }

    return rv;
}
