#include <iostream>
#include "cgul_cxx.h"

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    int i = 0;
    unsigned long value = 0;
    cgul_crc32_incr_cxx* crc = NULL;
    cgul_string_cxx label;

    try {

        /* Allocate. */
        crc = new cgul_crc32_incr_cxx(0x04c11db7, 0, 0xffffffff, 0, 0);

        /* Iterate over each file on the command line. */
        for (i = 1 ; i < argc ; ++i) {

            /* Calculate the CRC for this file. */
            crc->update_fname(argv[i]);
            value = crc->crc();

            /* Add this file to the list of files that have
             * contributed to the CRC. */
            if (label.get_length() > 0) {
                label.append(" + ");
            }
            label.append(argv[i]);

            /* Print the CRC. */
            printf("%lu  %s\n", value, label.get_value());
        }

    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    /* Clean up. */
    if (crc) {
        delete crc;
    }

    return rv;
}
