#include "cgul.h"

int main(int argc,
         char* argvp[])
{
    int rv = 0;
    size_t i = 0;
    cgul_hchar_t hello[] = {'h', 'e', 'l', 'l', 'o', 0};
    cgul_hstring_t hs = NULL;
    cgul_exception_t local = NULL;

    hs = cgul_hstring__new(&local);
    cgul_hstring__append(&local, hs, hello);
    cgul_hstring__pad_right(&local, hs, 10, (cgul_hchar_t)' ');
    if (local) {
        goto out;
    }

#if 0
    /* Try to run off the end of the allocated buffer by appending one
     * character at a time. */
    for (i = 0 ; i < 10000 ; ++i) {
        cgul_hstring__append_char(&local, hs, (cgul_hchar_t)'z');
    }
#endif

    for (i = 0 ; i < cgul_hstring__get_length(&local, hs) ; ++i) {
        cgul_hchar_t c = cgul_hstring__get_value_at(&local, hs, i);
        printf("c = %lu\n", (long unsigned)c);
    }

 out:

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    if (hs) {
        cgul_hstring__delete(hs);
    }

    return rv;
}
