#include "cgul_cxx.h"

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    char* s = NULL;

    try {

        /* Force an out-of-memory condition. */
        cgul_libc_cxx::set_out_of_memory(1);

        /* Try to allocate memory indirectly. */
        s = cgul_libc_cxx::strdup("Hello, World!");

    } catch (const cgul_exception_cxx& e) {
        fprintf(stderr, "*** Error: %s\n", e.get_message());
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        free(s);
    }

    return rv;
}
