#include <iostream>
#include <stdexcept>
#include "cgul_cxx.h"

using namespace std;

static void
print_list(cgul_list_cxx* lst)
{
    cgul_list_node_cxx* curr = NULL;

    for (curr = lst->get_front() ; curr ; curr = curr->get_next()) {
        cout << (char*)curr->get_value() << endl;
    }

    cout << "=====" << endl;
}

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_list_node_cxx* n1 = NULL;
    cgul_list_node_cxx* n2 = NULL;

    try {
        cgul_list_cxx lst;

        /* Insert static strings. */
        lst.push_back("foo");
        lst.push_back("bar");
        lst.push_back("baz");
        n1 = lst.push_back("zzz1");
        lst.push_back("zzz2");
        lst.push_back("zzz3");
        lst.push_back("zzz4");
        lst.push_back("zzz5");
        n2 = lst.push_back("zzz6");
        lst.push_back("zzz7");

        /* Print the list. */
        print_list(&lst);

        /* Remove a range of nodes. */
        lst.remove_range(n1, n2, NULL);

        /* Print the list. */
        print_list(&lst);

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    }

    return rv;
}
