#include "cgul_cxx.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    cgul_wchar_t wc = CGUL_WCHAR__NUL;
    char buffer[] = "\
text\n\
<!-- comment -->\n\
\n\
empty lines (above and below)\n\
\n\
";

    try {

        cgul_block_reader_memory_cxx br(buffer, strlen(buffer));
        cgul_stream_reader_cxx sr(br);

        while (sr.read(&wc)) {
            cout << "wc:" << (size_t)wc << "  "
                 << "line:" << sr.get_line_number_previous() << "  "
                 << "column:" << sr.get_column_number_previous() << endl;
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
