#include "cgul.h"

int main(int argc, char* argv[])
{
    int rv = 0;
    time_t t = 38923421;
    short h = 9;
    int i = -48;
    long l = -32;
    unsigned long lu = 0xabcd;
    size_t zu = 0xff;
    float f = 111.1117;
    double d = 222.2228;
    long double ld = 1.0L/3.0L;
    char c = '@';
    cgul_string_t s = NULL;
    cgul_exception_t local = NULL;

    /* Create a string. */
    s = cgul_string__new(&local);

    cgul_string__append_sprintf(&local,
                                s,
                                "timestamp_seconds: %lu\n",
                                (unsigned long)t);

    cgul_string__append_sprintf(&local, s, "char: %c\n", c);
    cgul_string__append_sprintf(&local, s, "short: %hd\n", h);
    cgul_string__append_sprintf(&local, s, "int: %05d\n", i);
    cgul_string__append_sprintf(&local, s, "long: %05ld\n", l);
    cgul_string__append_sprintf(&local, s, "unsigned long: %05lu\n", lu);
    cgul_string__append_sprintf(&local, s, "size_t: %05zu\n", zu);
    cgul_string__append_sprintf(&local, s, "octal: %05zo\n", zu);
    cgul_string__append_sprintf(&local, s, "hex (lower): %#05zx\n", zu);
    cgul_string__append_sprintf(&local, s, "hex (upper): %#05zX\n", zu);
    cgul_string__append_sprintf(&local, s, "float: %f\n", f);
    cgul_string__append_sprintf(&local, s, "double: %f\n", d);
    cgul_string__append_sprintf(&local, s, "long double: %Lf\n", ld);

    {
        const char* tmp = cgul_string__get_value(&local, s);
        cgul_libc__printf(&local, "%s", tmp);
    }

    /* Test cgul_string__set_capacity() by trying to walk off the end
     * of the allocated buffer by appending one character at a
     * time. */
    cgul_string__set_value(&local, s, "");
    for (i = 0 ; i < 500 ; ++i) {
        cgul_string__append_char(&local, s, 'z');
    }

    {
        const char* tmp = cgul_string__get_value(&local, s);
        cgul_libc__printf(&local, "%s\n", tmp);
    }

    /* Catch exceptions. */
    if (local) {
        const char* msg = cgul_exception__get_message(local);
        fprintf(stderr, "*** Error: %s\n", msg);
        cgul_exception__delete(local);
        local = NULL;
        rv = 1;
    }

    /* Clean up. */
    if (s) {
        cgul_string__delete(s);
    }

    return rv;
}
