#include "cgul_cxx.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i = 0;
    cgul_string_cxx s;

    try {

#if 0
        s.set_value("Hello, World!");
#endif

        /* Set the minimum capacity to 2 (one character plus NUL-terminator). */
        s.set_minimum_capacity(2);

        /* Create the string one character at a time.  Note that the
         * final string needs a capacity of (16 + 1) including the
         * NUL-terminator. */
        for (i = 0 ; i < 16 ; ++i) {

            /* Append the next character. */
            s.append_char('z');

            /* Print the new value of the string. */
            printf("-->%s<--\n", s.get_value());
        }

        /* Reduce the size of the string one character at a time. */
        for (i = s.get_length() ; i > 0 ; --i) {

            /* Reduce the size of the string by one by removing the
             * trailing character. */
            s.set_length(i - 1);

            /* Print the new value of the string. */
            printf("-->%s<--\n", s.get_value());
        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
