#include "cgul_cxx.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int
main(int argc,
     char* argv[])
{
    int rv = 0;
    size_t i = 0;
    cgul_vector_cxx v;

    try {

        /* Set the minimum capacity to 1. */
        v.set_minimum_capacity(1);

        /* Create the vector one value at a time. */
        for (i = 0 ; i < 17 ; ++i) {

            /* Append the next NULL value. */
            v.push_back(NULL);

        }

        /* Reduce the size of the vector one value at a time. */
        for (i = v.get_size() ; i > 0 ; --i) {

            /* Reduce the size of the vector by one. */
            v.pop_back();

        }

    } catch (const exception& e) {
        cerr << "*** Error: " << e.what() << endl;
        rv = 1;
    } catch (const cgul_exception_cxx& e) {
        cerr << "*** Error: " << e.get_message() << endl;
        rv = 1;
    }

    return rv;
}
