#include "cgul_cxx.h"
#include <iostream>
#include <stdexcept>

using namespace std;

int main(int argc,
         char* argvp[])
{
    int rv = 0;

    try {

        const char* utf8 = "64";
        cgul_wstring_cxx utf32;

        /* Convert from UTF-8 to UTF-32. */
        cgul_unicode_cxx::mbstowcs(utf8, strlen(utf8), 1, utf32);

        cout << "utf32.to_schar() = " << utf32.to_schar() << endl;
        cout << "utf32.to_uchar() = " << utf32.to_uchar() << endl;
        cout << "utf32.to_short() = " << utf32.to_short() << endl;
        cout << "utf32.to_ushort() = " << utf32.to_ushort() << endl;
        cout << "utf32.to_int() = " << utf32.to_int() << endl;
        cout << "utf32.to_unsigned() = " << utf32.to_unsigned() << endl;
        cout << "utf32.to_long() = " << utf32.to_long() << endl;
        cout << "utf32.to_unsigned_long() = "
             << utf32.to_unsigned_long() << endl;
        cout << "utf32.to_double() = " << utf32.to_double() << endl;

    } catch (const cgul_exception_cxx& e) {
        fprintf(stderr, "*** Error: %s\n", e.get_message());
        rv = 1;
    }

    return rv;
}
